// This file may be redistributed and modified only under the terms of
// the GNU General Public License (See COPYING for details).
// Copyright (C) 2003 Henri Kuuste

#ifndef _EF_ARCBALL_H_
#define _EF_ARCBALL_H_

#include <GL/gl.h>
#include <GL/glu.h>
#include <cmath>
#include <cal3d/cal3d.h>
#include "efmath.h"

/**
 * I have no clue what this class does!
 *
 *\todo Fix the documentation of this class
 */

class ArcBall {
 public:
  ArcBall(CalVector center, GLfloat radius);
  ~ArcBall() { };

  CalVector mapToSphere(CalVector p);
  void setDimensions(GLfloat radius);
  void setPosition(CalVector position);
  void mouse(CalVector vNow);
  void update();
  CalMatrix value();
  CalQuaternion qValue();
  void beginDrag();
  void endDrag();
  void setState(CalVector v);
  CalVector getState();
  void adjustRotation(CalQuaternion q);
	
  void render();
  void DrawDragArc();
  void DrawCursor();

 protected:
  GLfloat radius_;
  CalVector center_;
  CalQuaternion qNow_, qDown_, qDrag_, qAdjust_;
  CalVector vNow_, vDown_, vFrom_, vTo_;
  CalMatrix mNow_, mDown_;
  bool dragging_;
};

#endif
